
' WATERFALL (1999)
' 
'
'                                    Copyright (C) 1999, SEAV Softwares
'
'                                    This program written by Eugene Villar
'                                    a.k.a SEAV (evillar@geocities.com).
'
'                                    Visit my web site at
'                                    http://seav.findhere.com
'
' 
'
' This program draws a waterfall effect using
' a particle engine with motion blurring.
'
' Warning: I can't seem to compile this program correctly! I've located the
' problem to the lines marked with () but for the life of me, I can't
' figure out what's wrong. Anyway, it still looks cool running in the IDE.
' Adjust the number of particles by changing the statement below.
'
CONST Particles = 2000

DECLARE SUB PAL (Col%, R%, G%, B%)
DEFINT A-Z
RANDOMIZE TIMER

' Define water particles
TYPE particle
   x AS SINGLE
   y AS SINGLE
   dx AS SINGLE
   dy AS SINGLE
END TYPE
DIM Water(1 TO Particles) AS particle
FOR I = 1 TO Particles
   Water(I).x = RND * 70
   Water(I).y = RND * 149
   Water(I).dx = RND + .5
   Water(I).dy = RND
NEXT

' Define Sprite buffer
REM $STATIC
DIM Buffer(5474)
Buffer(0) = 576 'Width
Buffer(1) = 152 'Height
DEF SEG = VARSEG(Buffer(0))
FOR P = 4 TO 10947
   POKE P, 4
NEXT

' Define palette and screen items
SCREEN 13
FOR I = 0 TO 63
   PAL I, I \ 2, I * 2 \ 3, I
   PAL I + 64, I \ 3 + 31, (I \ 3 + 41), 63
NEXT
FOR I = 1 TO 48
   LINE (0, I + 100)-(319, I + 100), I
NEXT
FOR I = -1 TO 7
   PSET (I * 54 - 10, 141), 40: DRAW "c15bd5u3rd4r2u4rd4r2u4rnd3be2bd3ddfu4r3d4nl3ru4be2brd2nld3fnru4nru2br3bd3ddfnr3u4r3ddnl2rube2bubd2d4ru4r2flbe3bd2rnr2d4ru6gerbr2bd3ddfu4r3d4nl3ru4be2d6ru6br2d6ru6br2"
   PSET (I * 54 - 11, 140), 40: DRAW "c127bd5u3rd4r2u4rd4r2u4rnd3be2bd3ddfu4r3d4nl3ru4be2brd2nld3fnru4nru2br3bd3ddfnr3u4r3ddnl2rube2bubd2d4ru4r2flbe3bd2rnr2d4ru6gerbr2bd3ddfu4r3d4nl3ru4be2d6ru6br2d6ru6br2"
NEXT
LINE (70, 24)-STEP(73, 153), 32, B
LINE (71, 25)-STEP(71, 151), 4, B

' Define quotient/product/random tables
DIM Quot(635), Quot2(151), Prod(151)
DIM Rand(1000)
FOR I = 0 TO 635
   Quot(I) = I / 5.4
NEXT
FOR I = 0 TO 151
   Quot2(I) = (150 - I) / 150 * 118 + 3
   Prod(I) = I * 72 + 77
NEXT
FOR I = 0 TO 1000
   Rand(I) = RND * 5
NEXT


' Start loop
StartTime! = TIMER
DO
   
   ' Particle Engine
   FOR I = 1 TO Particles
      Col = Quot2(Water(I).y) + Rand(Frames MOD 1001)       '()
      POKE Water(I).x + INT(Water(I).y) * 72 + 77, Col      '()
      Water(I).x = Water(I).x + Water(I).dx
      Water(I).y = Water(I).y + Water(I).dy
      Water(I).dy = Water(I).dy + RND * .35
      IF Water(I).y > 149 OR Water(I).x > 69 THEN
         Water(I).x = RND * 5 + 5
         Water(I).y = RND * 5 + 5
         Water(I).dx = RND + .5
         Water(I).dy = RND / 10
      END IF
   NEXT
   
   ' Blur
   FOR P = 76 TO 10875
      Pixel = Quot(PEEK(P) + PEEK(P + 1) + PEEK(P - 1) + PEEK(P + 72) + PEEK(P - 72))
      POKE P, Pixel
   NEXT

   PUT (71, 25), Buffer, PSET

   Frames = Frames + 1

LOOP UNTIL LEN(INKEY$)
EndTime! = TIMER

SCREEN 0
WIDTH 80
Time! = EndTime! - StartTime!
PRINT Time!; " sec"
PRINT Frames / Time!; " fps"

SUB PAL (Col, R, G, B)
   OUT &H3C8, Col
   OUT &H3C9, R
   OUT &H3C9, G
   OUT &H3C9, B
END SUB

